Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Sony.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Sony.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Sony.pm	(revision 34921)
@@ -783,5 +4168,4 @@
     0x1f => { #7
         Name => 'ZoneMatchingValue',
-        Condition => '$$self{Model} !~ /DSLR-A230/',
         ValueConv => '$val - 10',
         ValueConvInv => '$val + 10',
@@ -791,5 +4175,4 @@
     0x22 => { #7
         Name => 'Brightness',
-        Condition => '$$self{Model} !~ /DSLR-A230/',
         ValueConv => '$val - 10',
         ValueConvInv => '$val + 10',
@@ -798,14 +4181,13 @@
     },
     0x23 => {
-        Name => 'FlashMode',
+        Name => 'FlashControl',
         PrintConv => {
             0 => 'ADI',
-            1 => 'TTL',
+            1 => 'Pre-flash TTL',
+            2 => 'Manual',
         },
     },
     0x28 => { #7
         Name => 'PrioritySetupShutterRelease',
-        Condition => '$$self{Model} =~ /DSLR-A700\b/',
-        Notes => 'A700 only',
         PrintConv => {
             0 => 'AF',
@@ -815,6 +4197,4 @@
     0x29 => { #7
         Name => 'AFIlluminator',
-        Condition => '$$self{Model} =~ /DSLR-A700\b/',
-        Notes => 'A700 only',
         PrintConv => {
             0 => 'Auto',
@@ -824,30 +4204,30 @@
     0x2a => { #7
         Name => 'AFWithShutter',
-        Condition => '$$self{Model} =~ /DSLR-A700\b/',
-        Notes => 'A700 only',
         PrintConv => { 0 => 'On', 1 => 'Off' },
     },
     0x2b => { #7
         Name => 'LongExposureNoiseReduction',
-        Condition => '$$self{Model} =~ /DSLR-A700\b/',
-        Notes => 'A700 only',
         PrintConv => { 0 => 'Off', 1 => 'On' },
     },
     0x2c => { #7
         Name => 'HighISONoiseReduction',
-        Condition => '$$self{Model} =~ /DSLR-A700\b/',
-        Notes => 'A700 only',
-        0 => 'Normal',
-        1 => 'Low',
-        2 => 'High',
-        3 => 'Off',
+        PrintConv => {
+            0 => 'Normal',
+            1 => 'Low',
+            2 => 'High',
+            3 => 'Off',
+        },
     },
     0x2d => { #7
         Name => 'ImageStyle',
-        Condition => '$$self{Model} =~ /DSLR-A700\b/',
-        Notes => 'A700 only',
+        PrintConvColumns => 2,
         PrintConv => {
             1 => 'Standard',
             2 => 'Vivid',
+            3 => 'Portrait', #PH
+            4 => 'Landscape', #PH
+            5 => 'Sunset', #PH
+            7 => 'Night View/Portrait', #PH (A200/A350 when CreativeStyle was 6!)
+            8 => 'B&W', #PH (guess)
             9 => 'Adobe RGB',
             11 => 'Neutral',
@@ -855,15 +4235,49 @@
             130 => 'StyleBox2',
             131 => 'StyleBox3',
-        },
-    },
-    # 0x2d - A900:1=?,4=?,129=std,130=vivid,131=neutral,132=portrait,133=landscape,134=b&w
+            132 => 'StyleBox4', #JR (A850)
+            133 => 'StyleBox5', #JR (A850)
+            134 => 'StyleBox6', #JR (A850)
+        },
+    },
+    0x2e => { #JR (may not apply to A200/A300/A350 -- they don't have the AF/MF button)
+        Name => 'FocusModeSwitch',
+        PrintConv => {
+            0 => 'AF',
+            1 => 'Manual',
+        },
+    },
+    0x2f => { #JR
+        Name => 'ShutterSpeedSetting',
+        Notes => 'used in M, S and Program Shift S modes',
+        ValueConv => '$val ? 2 ** (6 - $val/8) : 0',
+        ValueConvInv => '$val ? int((6 - log($val) / log(2)) * 8 + 0.5) : 0',
+        PrintConv => '$val ? Image::ExifTool::Exif::PrintExposureTime($val) : "Bulb"',
+        PrintConvInv => 'lc($val) eq "bulb" ? 0 : Image::ExifTool::Exif::ConvertFraction($val)',
+    },
+    0x30 => { #JR
+        Name => 'ApertureSetting',
+        Notes => 'used in M, A and Program Shift A modes',
+        ValueConv => '2 ** (($val/8 - 1) / 2)',
+        ValueConvInv => 'int((log($val) * 2 / log(2) + 1) * 8 + 0.5)',
+        PrintConv => 'Image::ExifTool::Exif::PrintFNumber($val)',
+        PrintConvInv => '$val',
+    },
     0x3c => {
         Name => 'ExposureProgram',
-        Priority => 0,
+        SeparateTable => 'ExposureProgram',
         PrintConv => \%sonyExposureProgram,
     },
     0x3d => {
-        Name => 'ImageStabilization',
+        Name => 'ImageStabilizationSetting',
         PrintConv => { 0 => 'Off', 1 => 'On' },
+    },
+    0x3e => { #JR
+        Name => 'FlashAction',
+        PrintConv => {
+            0 => 'Did not fire',
+            1 => 'Fired',
+            2 => 'External Flash, Did not fire',
+            3 => 'External Flash, Fired',
+        },
     },
     0x3f => { # (verified for A330/A380)
@@ -873,4 +4287,62 @@
             1 => 'Rotate 90 CW', #(NC)
             2 => 'Rotate 270 CW',
+        },
+    },
+    0x40 => { #JR
+        Name => 'AELock',
+        PrintConv => {
+            1 => 'Off',
+            2 => 'On',
+        },
+    },
+    0x4c => { #JR
+        Name => 'FlashAction2',
+        PrintConv => {
+            1 => 'Fired, Autoflash',
+            2 => 'Fired, Fill-flash',
+            3 => 'Fired, Rear Sync',
+            4 => 'Fired, Wireless',
+            5 => 'Did not fire',
+            6 => 'Fired, Slow Sync',
+            17 => 'Fired, Autoflash, Red-eye reduction',
+            18 => 'Fired, Fill-flash, Red-eye reduction',
+            34 => 'Fired, Fill-flash, HSS',
+        },
+    },
+    0x4d => { #JR
+        Name => 'FocusMode', # (focus mode actually used)
+        PrintConv => {
+            0 => 'Manual',
+            1 => 'AF-S',
+            2 => 'AF-C',
+            3 => 'AF-A',
+            4 => 'DMF', #JR
+        },
+    },
+    0x50 => { #JR
+        Name => 'BatteryState',
+        PrintConv => {
+            2 => 'Empty',      # 0%
+            3 => 'Very Low',   # 1 - 20%
+            4 => 'Low',        # 21 - 50%
+            5 => 'Sufficient', # 51 - 80%
+            6 => 'Full',       # > 80%
+        },
+    },
+    0x51 => { #JR
+        Name => 'BatteryLevel',
+        PrintConv => '"$val%"',
+        PrintConvInv => '$val=~s/\s*\%//; $val',
+    },
+    0x53 => { #JR
+        Name => 'FocusStatus',
+        PrintConv => {
+            0 => 'Not confirmed',
+            4 => 'Not confirmed, Tracking',
+            BITMASK => {
+                0 => 'Confirmed',
+                1 => 'Failed',
+                2 => 'Tracking',
+            },
         },
     },
@@ -908,15 +4380,135 @@
             50 => '1/2 EV',
         },
-    },            
+    },
+    0x6a => { #JR
+        Name => 'RedEyeReduction',
+        PrintConv => {
+            0 => 'Off',
+            1 => 'On',
+        },
+    },
+    0x9a => { #JR
+        Name => 'FolderNumber',
+        Mask => 0x03ff, # (not sure what the upper 6 bits are for)
+        PrintConv => 'sprintf("%.3d",$val)',
+        PrintConvInv => '$val',
+    },
+    0x9b => { #JR
+        Name => 'ImageNumber',
+        Mask => 0x3fff, # (not sure what the upper 2 bits are for)
+        PrintConv => 'sprintf("%.4d",$val)',
+        PrintConvInv => '$val',
+    },
 );
 
-# Camera settings (ref PH) (A330 and A380)
+# Camera settings (ref PH) (A230, A290, A330, A380 and A390)
 %Image::ExifTool::Sony::CameraSettings2 = (
     %binaryDataAttrs,
     GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
     FORMAT => 'int16u',
-    NOTES => 'Camera settings for the A330 and A380.',
-    0x10 => { #7 (A700, not confirmed for other models)
-        Name => 'FocusMode',
+    PRIORITY => 0,
+    NOTES => 'Camera settings for the A230, A290, A330, A380 and A390.',
+### 0x00-0x03: same TagID as CameraSettings
+    0x00 => { #JR
+        Name => 'ExposureTime',
+        ValueConv => '$val ? 2 ** (6 - $val/8) : 0',
+        ValueConvInv => '$val ? int((6 - log($val) / log(2)) * 8 + 0.5) : 0',
+        PrintConv => '$val ? Image::ExifTool::Exif::PrintExposureTime($val) : "Bulb"',
+        PrintConvInv => 'lc($val) eq "bulb" ? 0 : Image::ExifTool::Exif::ConvertFraction($val)',
+    },
+    0x01 => { #JR
+        Name => 'FNumber',
+        ValueConv => '2 ** (($val/8 - 1) / 2)',
+        ValueConvInv => 'int((log($val) * 2 / log(2) + 1) * 8 + 0.5)',
+        PrintConv => 'Image::ExifTool::Exif::PrintFNumber($val)',
+        PrintConvInv => '$val',
+    },
+    0x02 => { #JR (requires external flash)
+        Name => 'HighSpeedSync',
+        PrintConv => {
+            0 => 'Off',
+            1 => 'On',
+        },
+    },
+    0x03 => { #JR
+        Name => 'ExposureCompensationSet',
+        ValueConv => '($val - 128) / 24',
+        ValueConvInv => 'int($val * 24 + 128.5)',
+        PrintConv => '$val ? sprintf("%+.1f",$val) : 0',
+        PrintConvInv => 'Image::ExifTool::Exif::ConvertFraction($val)',
+    },
+### 0x04-0x11: subtract 1 from CameraSettings TagID
+    0x04 => { #JR
+        Name => 'WhiteBalanceSetting',
+        PrintConv => {
+            2 => 'Auto',
+            4 => 'Daylight',
+            5 => 'Fluorescent',
+            6 => 'Tungsten',
+            7 => 'Flash',
+            16 => 'Cloudy',
+            17 => 'Shade',
+            18 => 'Color Temperature/Color Filter',
+            32 => 'Custom 1',
+            33 => 'Custom 2',
+            34 => 'Custom 3',
+        },
+    },
+    0x05 => { #JR
+        Name => 'WhiteBalanceFineTune',
+        ValueConv => '$val > 128 ? $val - 256 : $val',
+        ValueConvInv => '$val < 0 ? $val + 256 : $val',
+    },
+    0x06 => { #JR as set in WB "Color Temperature/Color Filter" and in White Balance Bracketing
+        Name => 'ColorTemperatureSet',
+        ValueConv => '$val * 100',
+        ValueConvInv => '$val / 100',
+        PrintConv => '"$val K"',
+        PrintConvInv => '$val =~ s/ ?K$//i; $val',
+    },
+    0x07 => { #JR as set in WB "Color Temperature/Color Filter"
+        Name => 'ColorCompensationFilterSet',
+        Notes => 'negative is green, positive is magenta',
+        ValueConv => '$val > 128 ? $val - 256 : $val',
+        ValueConvInv => '$val < 0 ? $val + 256 : $val',
+        PrintConv => '$val > 0 ? "+$val" : $val',
+        PrintConvInv => '$val',
+    },
+    0x08 => { #JR
+        Name => 'CustomWB_RGBLevels',
+        Format => 'int16u[3]',
+    },
+    0x0b => { #JR as set in WB "Custom" and in White Balance Bracketing
+        Name => 'ColorTemperatureCustom',
+        ValueConv => '$val * 100',
+        ValueConvInv => '$val / 100',
+        PrintConv => '"$val K"',
+        PrintConvInv => '$val =~ s/ ?K$//i; $val',
+    },
+    0x0c => { #JR as set in WB "Custom"
+        Name => 'ColorCompensationFilterCustom',
+        Notes => 'negative is green, positive is magenta',
+        ValueConv => '$val > 128 ? $val - 256 : $val',
+        ValueConvInv => '$val < 0 ? $val + 256 : $val',
+        PrintConv => '$val > 0 ? "+$val" : $val',
+        PrintConvInv => '$val',
+    },
+    0x0e => { #JR
+        Name => 'WhiteBalance',
+        PrintConv => {
+            2 => 'Auto',
+            4 => 'Daylight',
+            5 => 'Fluorescent',
+            6 => 'Tungsten',
+            7 => 'Flash',
+            12 => 'Color Temperature',
+            13 => 'Color Filter',
+            14 => 'Custom',
+            16 => 'Cloudy',
+            17 => 'Shade',
+        },
+    },
+    0x0f => { #JR/PH (educated guess)
+        Name => 'FocusModeSetting',
         PrintConv => {
             0 => 'Manual',
@@ -924,7 +4516,8 @@
             2 => 'AF-C',
             3 => 'AF-A',
-        },
-    },
-    0x11 => { #JD (A700)
+            # seen 5 for A380 (FocusMode was Manual and FocusStatus was Confirmed)
+        },
+    },
+    0x10 => { #JR/PH (educated guess)
         Name => 'AFAreaMode',
         PrintConv => {
@@ -934,21 +4527,32 @@
         },
     },
-    0x12 => { #7 (A700, not confirmed for other models)
-        Name => 'LocalAFAreaPoint',
+    0x11 => { #JR/PH (educated guess)
+        Name => 'AFPointSetting',
         Format => 'int16u',
+        # The AF point as selected by the user in AFAreaMode=Local or Spot;
+        # Reported value remains at the last-set position in AFAreaModes=Wide.
+        # (all of these cameras have a 9-point centre-cross AF system, ref JR)
+        PrintConvColumns => 2,
         PrintConv => {
             1 => 'Center',
             2 => 'Top',
-            3 => 'Top-Right',
+            3 => 'Upper-right',
             4 => 'Right',
-            5 => 'Bottom-Right',
+            5 => 'Lower-right',
             6 => 'Bottom',
-            7 => 'Bottom-Left',
+            7 => 'Lower-left',
             8 => 'Left',
-            9 => 'Top-Left',
-            10 => 'Far Right',
-            11 => 'Far Left',
-            # see value of 128 for some models
-        },
+            9 => 'Upper-left',
+        },
+    },
+### 0x12-0x18: subtract 2 from CameraSettings TagID
+    0x12 => { #JR
+        Name => 'FlashExposureCompSet',
+        Description => 'Flash Exposure Comp. Setting',
+        # (as pre-selected by the user, not zero if flash didn't fire)
+        ValueConv => '($val - 128) / 24', #PH
+        ValueConvInv => 'int($val * 24 + 128.5)',
+        PrintConv => '$val ? sprintf("%+.1f",$val) : 0',
+        PrintConvInv => 'Image::ExifTool::Exif::ConvertFraction($val)',
     },
     0x13 => {
@@ -956,5 +4560,5 @@
         PrintConv => {
             1 => 'Multi-segment',
-            2 => 'Center-weighted Average',
+            2 => 'Center-weighted average',
             4 => 'Spot',
         },
@@ -977,9 +4581,8 @@
         },
     },
-    0x17 => {
-        Name => 'DynamicRangeOptimizerLevel',
-    },
+    0x17 => 'DynamicRangeOptimizerLevel',
     0x18 => { # A380
         Name => 'CreativeStyle',
+        PrintConvColumns => 2,
         PrintConv => {
             1 => 'Standard',
@@ -990,8 +4593,8 @@
             6 => 'Night View/Portrait',
             8 => 'B&W',
-            9 => 'Adobe RGB',
-            11 => 'Neutral',
-        },
-    },
+            # (these models don't have Neutral - PH)
+        },
+    },
+### 0x19-0x1b: subtract 3 from CameraSettings TagID
     0x19 => {
         Name => 'Sharpness',
@@ -1015,17 +4618,77 @@
         PrintConvInv => '$val',
     },
-    0x23 => {
-        Name => 'FlashMode',
+### 0x1c-0x24: subtract 4 from CameraSettings TagID (not sure about 0x1c)
+    0x1f => { #PH (educated guess)
+        Name => 'FlashControl',
         PrintConv => {
             0 => 'ADI',
-            1 => 'TTL',
-        },
-    },
-    # 0x27 - also related to CreativeStyle:
-    #  A380:1=std,2=vivid,3=portrait,4=landscape,5=sunset,7=night view,8=b&w
+            1 => 'Pre-flash TTL',
+            2 => 'Manual',
+        },
+    },
+### 0x25-0x27: subtract 6 from CameraSettings TagID
+    0x25 => { #PH
+        Name => 'LongExposureNoiseReduction',
+        PrintConv => { 0 => 'Off', 1 => 'On' },
+    },
+    0x26 => { #PH
+        Name => 'HighISONoiseReduction',
+        # (Note: the order is different from that in CameraSettings)
+        PrintConv => {
+            0 => 'Off',
+            1 => 'Low',
+            2 => 'Normal',
+            3 => 'High',
+        },
+    },
+    0x27 => { #PH
+        Name => 'ImageStyle',
+        PrintConvColumns => 2,
+        PrintConv => {
+            1 => 'Standard',
+            2 => 'Vivid',
+            3 => 'Portrait', #PH
+            4 => 'Landscape', #PH
+            5 => 'Sunset', #PH
+            7 => 'Night View/Portrait', #PH (A200 when CreativeStyle was 6!)
+            8 => 'B&W', #PH (A380)
+            # (these models don't have Neutral - PH)
+        },
+    },
+### 0x28-0x3b: subtract 7 from CameraSettings TagID
+    0x28 => { #PH
+        Name => 'ShutterSpeedSetting',
+        Notes => 'used in M, S and Program Shift S modes',
+        ValueConv => '$val ? 2 ** (6 - $val/8) : 0',
+        ValueConvInv => '$val ? int((6 - log($val) / log(2)) * 8 + 0.5) : 0',
+        PrintConv => '$val ? Image::ExifTool::Exif::PrintExposureTime($val) : "Bulb"',
+        PrintConvInv => 'lc($val) eq "bulb" ? 0 : Image::ExifTool::Exif::ConvertFraction($val)',
+    },
+    0x29 => { #PH
+        Name => 'ApertureSetting',
+        Notes => 'used in M, A and Program Shift A modes',
+        ValueConv => '2 ** (($val/8 - 1) / 2)',
+        ValueConvInv => 'int((log($val) * 2 / log(2) + 1) * 8 + 0.5)',
+        PrintConv => 'Image::ExifTool::Exif::PrintFNumber($val)',
+        PrintConvInv => '$val',
+    },
+### 0x3c-0x59: same TagID as CameraSettings
     0x3c => {
         Name => 'ExposureProgram',
-        Priority => 0,
+        SeparateTable => 'ExposureProgram',
         PrintConv => \%sonyExposureProgram,
+    },
+    0x3d => { # (copied from CameraSettings, ref JR)
+        Name => 'ImageStabilizationSetting',
+        PrintConv => { 0 => 'Off', 1 => 'On' },
+    },
+    0x3e => { #JR
+        Name => 'FlashAction',
+        PrintConv => {
+            0 => 'Did not fire',
+            1 => 'Fired',
+            2 => 'External Flash, Did not fire',
+            3 => 'External Flash, Fired',
+        },
     },
     0x3f => { # (verified for A330/A380)
@@ -1037,4 +4700,46 @@
         },
     },
+    0x40 => { #JR
+        Name => 'AELock',
+        PrintConv => {
+            1 => 'Off',
+            2 => 'On',
+        },
+    },
+    0x4c => { #JR
+        Name => 'FlashAction2',
+        PrintConv => {
+            1 => 'Fired, Autoflash',
+            2 => 'Fired, Fill-flash',
+            3 => 'Fired, Rear Sync',
+            4 => 'Fired, Wireless',
+            5 => 'Did not fire',
+            6 => 'Fired, Slow Sync',
+            17 => 'Fired, Autoflash, Red-eye reduction',
+            18 => 'Fired, Fill-flash, Red-eye reduction',
+            34 => 'Fired, Fill-flash, HSS',
+        },
+    },
+    0x4d => { #JR
+        Name => 'FocusMode', # (focus mode actually used)
+        PrintConv => {
+            0 => 'Manual',
+            1 => 'AF-S',
+            2 => 'AF-C',
+            3 => 'AF-A',
+        },
+    },
+    0x53 => { #JR (copied from CameraSettings, but all bits may not be applicable for these models)
+        Name => 'FocusStatus',
+        PrintConv => {
+            0 => 'Not confirmed',
+            4 => 'Not confirmed, Tracking',
+            BITMASK => {
+                0 => 'Confirmed',
+                1 => 'Failed',
+                2 => 'Tracking',
+            },
+        },
+    },
     0x54 => {
         Name => 'SonyImageSize',
